// =====================  GrLib.cpp =====================
//
//   㭪樨 ⥭  䠩  뢮  ࠭ ࠦ
//    ଠ .PCX.
// ==========================================================



#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
#include <graphics.h>
#include "grega.h"



// --------   䠩 ଠ .PCX -----------
struct PCXHEADER
{ char  manuf;		//ᥣ = 10  Paintbrush
  char  hard;		// 
  char  encod;		//稥 㯯 ஢ (=1)
  char  bitpx;		//-  ᪮   ᥫ
  int   x1;		//ࠧ ⨭ ( ࠭)
  int   y1;
  int   x2;
  int   y2;
  int   hres;		//⨪쭮  ਧ⠫쭮 ࠧ襭
  int   vres;		//ᯫ,  ஬ ᮧ ࠦ
  char  clrma[48];	//
  char  vmode;		//
  char  nplanes;	//⢮ ᪮⥩ ( ᨨ 2.5 = 0)
  int   bplin;		//  ப
  int   palinfo;	// (1-梥⭠, 2-୮-)
  int   shres;		//ࠧ襭 ᪠
  int   svres;
  char  xtra[54];	//१ࢭ  (䨫)
};// ------    䠩 ଠ .PCX ---------



static  PCXHEADER  h;

int  op = REPLACE;			//᪠   㬮砭




// ============ ⠭ ᪮ 樨 =================
void setOperation(int operation)
{  op = operation; }
// =========  ⠭ ᪮ 樨 ==============




// ================ ⠭ ॣ஢ ========================
void  openScreen(unsigned char color)
{ SETREG(GDC, GDCReset, color);		// 梥  ॣ set/reset
  SETREG(GDC, GDCEnable, 0x0F);         //⨥ ᪮⥩  
  SETREG(GDC, GDCDataRotate, op<<3);    //᪠   梥⮬
} // =============  ⠭ ॣ஢ ===================





// ========== ⠭ ॣ஢  㬮砭 ==================
void  closeScreen(void)
{ SETREG(GDC, GDCBitMask, 0xFF);     	//᪠ ⮢  㬮砭
  SETREG(GDC, GDCEnable, 0x00);         //⨥ ᪮⥩  
  SETREG(GDC, GDCDataRotate, REPLACE);  //᪠   㬮砭
}// ========  ⠭ ॣ஢  㬮砭 ==============





// ==================== ⠭ ० ======================
void setMode(int mod)
{  union REGS r;
   r.h.ah = 0;
   r.h.al = mod;
   int86(0x10, &r, &r);
}// ================  ⠭ ० ====================






// ======== 뢠 ࠧ ࠦ 䠩 *.pcx =========
void PCXGetSize(char *fname, int *x1, int *x2, int *y1, int *y2)
{  FILE  *fp;
   int len = sizeof(PCXHEADER);
   fp = fopen(fname, "rb");
   if (fp==NULL)
    { printf(" %s  !  - PCXGetSize.\n", fname);
      return;
    }
  fread(&h, len, 1, fp);		// ⥭  䠩
  *x1 = h.x1;
  *x2 = h.x2;
  *y1 = h.y1;
  *y2 = h.y2;
} // =====  뢠 ࠧ ࠦ 䠩 *.pcx =====





// ============    祭 梥 ===============
void setPalette(unsigned char i,
		unsigned char red,
		unsigned char green,
		unsigned char blue)
{ union REGS  r;
  r.h.ah = 0x10;
  r.h.al = 1;
  r.h.bl = i;
  r.h.bh = (red  %2) * 32 + (red  /2) * 4 +
	   (green%2) * 16 + (green/2) * 2 +
	   (blue %2) * 8  + (blue /2);
  int86(0x10, &r, &r);
} // =========     祭 梥 ===========





// ================ 뢠  梥⮢ ===================
void PCXSetPalette(char *fname)
{  FILE *fp;
   int len = sizeof(PCXHEADER);
   int r;

   fp = fopen(fname, "rb");
   if (fp==NULL)
    { printf(" %s  !  - PCXSetPalette.\n", fname);
      return;
    }
   fread(&h, len, 1, fp);		//⥭  䠩
   for (r=0; r<16; r++)			//뢠 
    {  setPalette(r, h.clrma[3*r  ]/64,
		     h.clrma[3*r+1]/64,
		     h.clrma[3*r+2]/64);
    }
} // =============  뢠  梥⮢ =============






// ================ 뢮 ப ᥫ  ࠭ ===============
void  LinePixel
(unsigned char far *planes,	//㪠⥫ 
	  int  skipByte,	//᪮쪮 ⮢ ய
 unsigned char beginMask,	//砫쭠 ᪠
	  int  fullByte,	//᪮쪮 ⮢ 뢥
 unsigned char endMask,		//筠 ᪠
 unsigned int x,		// ப  ࠭
 unsigned int y
)
{ unsigned char far *pl;	//⥪騩 㪠⥫  ப
  unsigned char far *m;		//⥪騩 㪠⥫  
  unsigned char far *strBeg;	//砫 ப  
  unsigned int  k;		//ࠡ ६
  unsigned char c;		//ࠡ ६
  int npl = 4;			//᫮ ᪮⥩

 strBeg = MEMORYOF(x, y);  //砫 ப   ( ࠭ )

// ------  ப  ࠭ 梥⮬ 䮭 -------
  pl = planes + skipByte;
  m = strBeg;
    setOperation(REPLACE);
    openScreen(0);
  if (beginMask!=0)  {SETMASK(beginMask); c = *m; *m = 0; m++; pl++;}
  for(k=0; k<fullByte; k++)  {SETMASK(0xFF); c = *m; *m = 0; m++; pl++;}
  if (endMask!=0)  {SETMASK(endMask); c = *m;  *m = 0;}

// ---------- 뢮  㫥 ᪮ -----------
     pl = planes + skipByte;
     m = strBeg;
     setOperation(REPLACE);
     openScreen(1);
  if (beginMask!=0)  {SETMASK(*pl & beginMask); c = *m; *m = 0; m++; pl++;}
  for(k=0; k<fullByte; k++)  {SETMASK(*pl); c = *m; *m = 0; m++; pl++;}
  if (endMask!=0)  {SETMASK(*pl & endMask);  c = *m; *m = 0;}

// ---------- 뢮   ᪮ -----------
  if (npl>1)
   { pl = planes + skipByte + h.bplin;
     m = strBeg;
     setOperation(OR);
     openScreen(2);
  if (beginMask!=0)  {SETMASK(*pl & beginMask); c = *m; *m = 0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SETMASK(*pl);  c = *m; *m = 0; m++; pl++;}
  if (endMask!=0)  {SETMASK(*pl & endMask);  c = *m;  *m = 0;}
   }

// ---------- 뢮   ᪮ -----------
  if (npl>2)
   { pl = planes + skipByte + 2 * h.bplin;
     m = strBeg;
     openScreen(4);
  if (beginMask!=0)  {SETMASK(*pl & beginMask); c = *m; *m = 0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SETMASK(*pl);  c = *m; *m = 0; m++; pl++;}
  if (endMask!=0)  {SETMASK(*pl & endMask);  c = *m;  *m = 0;}
   }

// ---------- 뢮   ᪮ -----------
  if (npl>3)
   { pl = planes + skipByte + 3 * h.bplin;
     m = strBeg;
     openScreen(8);
  if (beginMask!=0)  {SETMASK(*pl & beginMask); c = *m; *m = 0; m++; pl++;}
  for (k=0; k<fullByte; k++)  {SETMASK(*pl);  c = *m; *m = 0; m++; pl++;}
  if (endMask!=0)  {SETMASK(*pl & endMask);  c = *m; *m = 0;}
   }

   setOperation(REPLACE);
   openScreen(1);
   closeScreen();
   c = c;		//⮡  Warning  樨
} // ============  뢮 ப ᥫ  ࠭ ==============







// ====================== 뢮 ⨭  ࠭ ====================
// 頥: 1-䠩  ; 2-⨭  뢥
int PCXWrite(char *fname,		// 䠩
	int dx, int dy,		//ᬥ饭 ࠣ
	int dw, int dh,		//ਭ   ࠣ
	int xS, int yS)		// ࠣ  ࠭
{
   FILE *fp;
   int    skipByte,		//᪮쪮 ⮢ ய
	  fullByte;		//᫮  ⮢
unsigned char beginMask,	//砫쭠 ᪠
	      endMask;		//筠 ᪠
   int k,			//ࠡ. ६
       n,			// ப   (㬬ୠ)
       y,			//⥪ ப
       l,			//ࠡ ६
       rep_count = 0,		//稪  ⮢
       len = sizeof(PCXHEADER);	//  䠩
  unsigned char far *planes;	//  ᯠ ப
  unsigned char	   c,		//࠭⥫ 
		bits;		//࠭⥫ ⮢

int l1;


// -------- ⨥ 䠩 -----------
    fp = fopen(fname, "rb");

    if (fp==NULL)  return 1;	//䠩  ; ਩ 室

   fread(&h, len, 1, fp);		//⥭  䠩

   n = h.nplanes * h.bplin;	//᫮ ᪮⥩ * ᫮ ⮢  ப
   planes = (unsigned char far*)malloc(n+4);   //  ᯠ ப

// -------  室   ⨬ --------
    if (dw<0 || dh<0)  return 2;
    if (dx<0)
      { if (dw+dx<=0) return 2;  else {dw+=dx; dx = 0;} }
    if (dy<0)
      { if (dh+dy<=0) return 2;  else {dh+=dy; dy = 0;} }
  if (xS+dw>getmaxx()+1)  dw=getmaxx()-xS;
  if (yS+dh>getmaxy()+1)  dh=getmaxy()-yS;
  if (xS>getmaxx() || yS>getmaxy())  return 2;
   if (xS<0)
     if (dw+xS>0)  {dw+=xS;  dx-=xS; xS=0;}  else return 2;

// ---------- । 稪  ᮪ -------------
   skipByte = ((h.x1 & 0x7)+dx) >> 3;		//ய ⮢
   beginMask = 0xFF>>(xS & 0x7);		//砫쭠 ᪠
   fullByte = (dw-(8-(xS & 0x7))) >> 3;		//᫮  ⮢
   endMask = 0xFF << (8-((xS+dw) & 0x7));	//筠 ᪠

// --------- 뢮 ࠦ ---------
   for (y=0; y<=h.y2-h.y1; y++)
 {   k = 0;
     while (k<n)		// ᯠ  ப
      { fread(&c, 1, 1, fp);
	 if ((c & 0xC0)==0xC0)
	   { rep_count = (c & 0x3F); fread(&bits, 1, 1, fp); }
	 else  { rep_count = 1; bits = c; }
	for (l=0; l<rep_count; l++) { planes[k+l] = bits; }
	k+=rep_count;
      }
     if (y>=dy+dh || y>h.y2-h.y1-dy || y>getmaxy()-yS-dy)  break;
 if (y>=dy)
  {
   l = ((h.x1+dx) & 0x7) - (xS & 0x7);	//ᬥ饭  (h.x1+dx)  xS
// --------- ᤢ 뢮 ப  稭 ᬥ饭 ----------
  if (l>0)			//ᤢ   l ᥫ
    { c = 0xFF<<(8-l);
      for (k=0; k<n; k++)
       { planes[k] <<= l;
	 bits = planes[k+1] & c;
	 planes[k] |= (bits >>= (8-l));
       }
    }
  if (l<0)			//ᤢ ࠢ  l ᥫ
    { c = 0xFF>>(8+l);
      for (k=n+2; k>=0; k--)
       { bits = (planes[k] & c);
	 planes[k+1] |= (bits <<= (8+l));
	 planes[k] >>= -l;
       }
    }
   LinePixel(planes, skipByte, beginMask, fullByte, endMask, xS, yS+y-dy);
  }
 }
// ------ ⮢  室 --------
   setOperation(REPLACE);
   openScreen(1);
   closeScreen();
   farfree(planes);
   fclose(fp);
   return 0;
} // ================  뢮 ⨭  ࠭ =================

